/// @cond EO_CXX_EO_IMPL

#ifdef ELM_INTERFACE_ATSPI_VALUE_PROTECTED
inline void elm_interface_atspi_value::value_and_text_get(double* value_, const char ** text_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_interface_atspi_value_and_text_get(value_, text_));
}
#endif

#ifdef ELM_INTERFACE_ATSPI_VALUE_PROTECTED
inline bool elm_interface_atspi_value::value_and_text_set(double value_, ::efl::eina::string_view text_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_atspi_value_and_text_set(value_, ::efl::eolian::to_c(text_)));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}
#endif

#ifdef ELM_INTERFACE_ATSPI_VALUE_PROTECTED
inline void elm_interface_atspi_value::range_get(double* lower_limit_, double* upper_limit_, const char ** description_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_interface_atspi_value_range_get(lower_limit_, upper_limit_, description_));
}
#endif

#ifdef ELM_INTERFACE_ATSPI_VALUE_PROTECTED
inline double elm_interface_atspi_value::increment_get() const
{
   double _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_atspi_value_increment_get());
   return _tmp_ret;
}
#endif

#ifdef ELM_INTERFACE_ATSPI_VALUE_PROTECTED
inline void eo_cxx::elm_interface_atspi_value::value_and_text_get(double* value_, const char ** text_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_interface_atspi_value_and_text_get(value_, text_));
}
#endif

#ifdef ELM_INTERFACE_ATSPI_VALUE_PROTECTED
inline bool eo_cxx::elm_interface_atspi_value::value_and_text_set(double value_, ::efl::eina::string_view text_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_atspi_value_and_text_set(value_, ::efl::eolian::to_c(text_)));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}
#endif

#ifdef ELM_INTERFACE_ATSPI_VALUE_PROTECTED
inline void eo_cxx::elm_interface_atspi_value::range_get(double* lower_limit_, double* upper_limit_, const char ** description_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_interface_atspi_value_range_get(lower_limit_, upper_limit_, description_));
}
#endif

#ifdef ELM_INTERFACE_ATSPI_VALUE_PROTECTED
inline double eo_cxx::elm_interface_atspi_value::increment_get() const
{
   double _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_atspi_value_increment_get());
   return _tmp_ret;
}
#endif

inline ::eo_cxx::elm_interface_atspi_value::operator ::elm_interface_atspi_value() const
{
   return *static_cast<::elm_interface_atspi_value const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::elm_interface_atspi_value::operator ::elm_interface_atspi_value&()
{
   return *static_cast<::elm_interface_atspi_value*>(static_cast<void*>(this));
}

inline ::eo_cxx::elm_interface_atspi_value::operator ::elm_interface_atspi_value const&() const
{
   return *static_cast<::elm_interface_atspi_value const*>(static_cast<void const*>(this));
}

#ifdef ELM_INTERFACE_ATSPI_VALUE_PROTECTED
template <typename T>
void _elm_interface_atspi_value_value_and_text_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, double* value_, const char ** text_)
{
   try
      {
         static_cast<T*>(self->this_)->value_and_text_get(value_, text_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}
#endif

#ifdef ELM_INTERFACE_ATSPI_VALUE_PROTECTED
template <typename T>
bool _elm_interface_atspi_value_value_and_text_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, double value_, const char * text_)
{
   try
      {
         return static_cast<T*>(self->this_)->value_and_text_set(value_, ::efl::eolian::to_cxx<::efl::eina::string_view>(text_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}
#endif

#ifdef ELM_INTERFACE_ATSPI_VALUE_PROTECTED
template <typename T>
void _elm_interface_atspi_value_range_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, double* lower_limit_, double* upper_limit_, const char ** description_)
{
   try
      {
         static_cast<T*>(self->this_)->range_get(lower_limit_, upper_limit_, description_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}
#endif

#ifdef ELM_INTERFACE_ATSPI_VALUE_PROTECTED
template <typename T>
double _elm_interface_atspi_value_increment_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->increment_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         double _tmp_ret{};
         return _tmp_ret;
      }
}
#endif

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm_interface_atspi_value >
{
   template <typename T>
   struct type
   {
#ifdef ELM_INTERFACE_ATSPI_VALUE_PROTECTED
      virtual void value_and_text_get(double* value_, const char ** text_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_interface_atspi_value_and_text_get(value_, text_));
      }
#endif

#ifdef ELM_INTERFACE_ATSPI_VALUE_PROTECTED
      virtual bool value_and_text_set(double value_, ::efl::eina::string_view text_)
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_value_and_text_set(value_, ::efl::eolian::to_c(text_)));
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
#endif

#ifdef ELM_INTERFACE_ATSPI_VALUE_PROTECTED
      virtual void range_get(double* lower_limit_, double* upper_limit_, const char ** description_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_interface_atspi_value_range_get(lower_limit_, upper_limit_, description_));
      }
#endif

#ifdef ELM_INTERFACE_ATSPI_VALUE_PROTECTED
      virtual double increment_get()
      {
         double _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_value_increment_get());
            return _tmp_ret;
      }
#endif

   };
};


template<>
struct operation_description_class_size< ::elm_interface_atspi_value >
{
   static constexpr int value = 
#if defined(ELM_INTERFACE_ATSPI_VALUE_PROTECTED) && defined(ELM_INTERFACE_ATSPI_VALUE_BETA)
      4
#elif defined(ELM_INTERFACE_ATSPI_VALUE_PROTECTED)
      4
#elif defined(ELM_INTERFACE_ATSPI_VALUE_BETA)
      0
#else
      0
#endif
;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::elm_interface_atspi_value>
                                 , Eo_Op_Description* ops)
{
   int i = 0;
   (void)i;
   (void)ops;
#ifdef ELM_INTERFACE_ATSPI_VALUE_PROTECTED
   ops[i].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_value_value_and_text_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_value_and_text_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;
#endif

#ifdef ELM_INTERFACE_ATSPI_VALUE_PROTECTED
   ops[i].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_value_value_and_text_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_value_and_text_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;
#endif

#ifdef ELM_INTERFACE_ATSPI_VALUE_PROTECTED
   ops[i].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_value_range_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_value_range_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;
#endif

#ifdef ELM_INTERFACE_ATSPI_VALUE_PROTECTED
   ops[i].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_value_increment_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_value_increment_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;
#endif

   return 0;
}
inline Eo_Class const* get_eo_class(tag<::elm_interface_atspi_value>)
{
   return (ELM_INTERFACE_ATSPI_VALUE_INTERFACE);
}

} } }

/// @endcond

